## mupdf 1.24.10+ds1

=== debian/changelog ===
mupdf (1.24.10+ds1-1) unstable; urgency=medium

  * New upstream version 1.24.10+ds1
  * debian/mupdf.docs
    + Don't install COPYING file to avoid lintian warning.
  * debian/control
    + Update Vcs-* fields, the repo was moved to debian group.
    + Add python3-sphinx-rtd-theme,furo and rst2pdf in B-D.
    + Add libjs-sphinxdoc in Depends.
  * Add mupdf.links file
    + Add symlinks to use debian js libs instead embedded Js libs.
  * debian/rules
    + Add override to install html doc. (Closes: #952284)
  * Add debian/mupdf.doc-base file.
  * Use wrap-and-sort

 -- Daniel Echeverri <epsilon@debian.org>  Thu, 10 Oct 2024 18:49:53 -0500

mupdf (1.24.9+ds1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    + Add myself as uploader. (Closes: #1073285)
    + Add python3-docutils and python3-pygments in BD to build manpages.
  * debian/watch
    + bump version to 4.
  * debian/source/lintian-overrides
    + Remove unused lintian override.
  * debian/*.lintian-overrides
    + Add lintian overrides about new manpages.
  * debian/copyright
    + Add myself in debian holders copyright.
  * Add debian/upstream/metadata file.
  * Add debian/create_tools_manpages.sh
    + to create a missing tools manpages.
  * debian/clean
    + Add output_files entry.
  * debian/rules
    + Add dh_installmanpages override to install missing manpages.
  * debian/mupdf-tools.manpages
    + Install muraster manpage.
  * debian/mupdf.manpages
    + Install mupdf-gl manpage.

 -- Daniel Echeverri <epsilon@debian.org>  Thu, 19 Sep 2024 20:09:48 -0500

mupdf (1.24.8+ds2-2) unstable; urgency=medium

  * debian/control: libmupdf-dev should depend on libfreetype-dev
    (Closes: #1079519)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 27 Aug 2024 21:09:32 +0900

mupdf (1.24.8+ds2-1) unstable; urgency=medium

  * New upstream version 1.24.8+ds2
  * debian/mupdf.install: Install all icons
  * debian/patches: Add patch to use Charis SIL ttf font directly
  * debian/control: bump standards-version to 4.7.0, no changes needed
  * debian/copyright: exclude generated files
  * debian/control: switch pkg-config to pkgconf

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 23 Aug 2024 08:26:03 +0900

=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Uploaders: Daniel Echeverri <epsilon@debian.org>
Build-Depends: afdko-bin:native,
               debhelper-compat (= 13),
               fonts-droid-fallback,
               fonts-noto-cjk,
               fonts-noto-core,
               fonts-sil-charis,
               fonts-urw-base35,
               freeglut3-dev,
               furo,
               libfreetype-dev,
               libgumbo-dev,
               libharfbuzz-dev,
               libjbig2dec0-dev (>= 0.20),
               libjpeg-dev,
               liblcms2-dev,
               libmujs-dev,
               libopenjp2-7-dev,
               libssl-dev,
               libx11-dev,
               libxext-dev,
               pkgconf,
               python3-docutils,
               python3-pygments,
               python3-sphinx-rtd-theme,
               python3:any,
               rst2pdf,
               texlive-fonts-extra,
               unzip,
               zlib1g-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://mupdf.com/
Vcs-Git: https://salsa.debian.org/debian/mupdf.git
Vcs-Browser: https://salsa.debian.org/debian/mupdf

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: libfreetype-dev, ${misc:Depends}
Built-Using: ${Built-Using}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the static library and headers.

Package: mupdf
Architecture: any
Depends: libjbig2dec0 (>= 0.19),
         libjs-sphinxdoc,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${Built-Using}
Suggests: mupdf-tools
Provides: pdf-viewer
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: libjbig2dec0 (>= 0.19), ${misc:Depends}, ${shlibs:Depends}
Description: command line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains command line tools using the MuPDF library:
  - mutool - tool for clean, extract, inspect PDF documents and
             render PDF/XPS/CBZ documents.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# Set CC for crossbuild
export CC_FOR_BUILD ?= cc
export PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
# ICC support needs patched thirdparty liblcms2-art
CFLAGS += -DFZ_ENABLE_ICC=0
CFLAGS += -fPIC

BUILD_FLAGS = build=debian OS=Linux XCFLAGS="$(CFLAGS)" XLDFLAGS="$(LDFLAGS)" prefix=/usr
# Force using system library
BUILD_FLAGS += USE_SYSTEM_MUJS=yes
BUILD_FLAGS += USE_SYSTEM_LIBS=yes
# Force using system lcms2 (was not included in default system library set)
BUILD_FLAGS += USE_SYSTEM_LCMS2=yes
BUILD_FLAGS += LD=$(DEB_HOST_GNU_TYPE)-ld


ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	BUILD_FLAGS += verbose=yes
endif

ifeq ($(DEB_TARGET_ARCH),mips64el)
	BUILD_FLAGS += HAVE_OBJCOPY=no
endif

override_dh_auto_build:
	debian/replace-fonts.sh
	-mkdir source/pdf/cmaps
	sh scripts/runcmapdump.sh
	dh_auto_build -- $(BUILD_FLAGS)

override_dh_auto_install:
	dh_auto_install -- $(BUILD_FLAGS)
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf
	sh debian/install_icons.sh
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C $(CURDIR)/debian/tests test
endif

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W fonts-droid-fallback fonts-noto-cjk fonts-noto-core fonts-sil-charis fonts-urw-base35 texlive-fonts-extra)"

override_dh_clean:
	dh_clean -Xresources/fonts/urw/input/NimbusBoxes.t1

override_dh_auto_clean:
	-rm -rf build
	-rm -rf generated
	-rm -rf source/pdf/cmaps
	-rm -f resources/fonts/sil/CharisSIL*.ttf

override_dh_missing:
	dh_missing --list-missing -X COPYING

override_dh_installman:
	$(CURDIR)/debian/create_tools_manpages.sh docs/src/mupdf-command-line.rst
	#remove GLUC because rst2man fails to invalid target name
	sed -i 's/GLUT_ /GLUT/g' $(CURDIR)/output_files/mupdf-gl.rst

	#convert to manpage
	rst2man $(CURDIR)/output_files/mupdf-gl.rst $(CURDIR)/debian/tmp/usr/share/man/mupdf-gl.1
	rst2man $(CURDIR)/output_files/muraster.rst $(CURDIR)/debian/tmp/usr/share/man/muraster.1
	dh_installman

override_dh_installdocs:
	sphinx-build -M html $(CURDIR)/docs/src/ $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/html/_sources
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/html/_static/[doctools.js,language_data.js,searchtools.js]
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/doctrees
	dh_installdocs

%:
	dh $@

## mupdf 1.25.1%2Bds1

=== debian/control ===
--- 
+++ 
@@ -24,15 +24,21 @@
                libx11-dev,
                libxext-dev,
                pkgconf,
+	       dh-sequence-python3,
+               python3-all-dev,
+               python3-clang,
                python3-docutils,
+               python3-roman,
                python3-pygments,
+               python3-sphinx-copybutton,
                python3-sphinx-rtd-theme,
-               python3:any,
+	       python3-sphinx,
                rst2pdf,
+               swig,
                texlive-fonts-extra,
                unzip,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://mupdf.com/
 Vcs-Git: https://salsa.debian.org/debian/mupdf.git
@@ -41,20 +47,33 @@
 Package: libmupdf-dev
 Architecture: any
 Section: libdevel
-Depends: libfreetype-dev, ${misc:Depends}
+Depends: libfreetype-dev, libmupdf25.1 (= ${binary:Version}), ${misc:Depends}
 Built-Using: ${Built-Using}
 Description: development files for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
  It also reads XPS, OpenXPS and ePub documents.
  .
- This package contains the static library and headers.
+ This package contains the static the unversioned library and headers.
+
+Package: libmupdf25.1
+Architecture: any
+Section: libs
+Depends: libjbig2dec0 (>= 0.19), ${misc:Depends}, ${shlibs:Depends}
+Built-Using: ${Built-Using}
+Description: shared library for the MuPDF viewer
+ MuPDF is a lightweight PDF viewer and toolkit written in portable C.
+ It also reads XPS, OpenXPS and ePub documents.
+ .
+ This package contains the shared library libmupdf and libmupdfcpp.
 
 Package: mupdf
 Architecture: any
 Depends: libjbig2dec0 (>= 0.19),
          libjs-sphinxdoc,
+         libmupdf25.1 (= ${binary:Version}),
          ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+	     ${sphinxdoc:Depends}
 Built-Using: ${Built-Using}
 Suggests: mupdf-tools
 Provides: pdf-viewer
@@ -69,7 +88,10 @@
 
 Package: mupdf-tools
 Architecture: any
-Depends: libjbig2dec0 (>= 0.19), ${misc:Depends}, ${shlibs:Depends}
+Depends: libjbig2dec0 (>= 0.19),
+         libmupdf25.1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: command line tools for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
  It also reads XPS, OpenXPS and ePub documents.
@@ -77,3 +99,12 @@
  This package contains command line tools using the MuPDF library:
   - mutool - tool for clean, extract, inspect PDF documents and
              render PDF/XPS/CBZ documents.
+
+Package: python3-mupdf
+Architecture: any
+Depends: libmupdf25.1 (= ${binary:Version}), ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Description: Python bindings for MuPDF library
+ MuPDF is a lightweight PDF viewer and toolkit written in portable C.
+ It also reads XPS, OpenXPS and ePub documents.
+ .
+ This package contains the contains low level mupdf Python bindings.

## mupdf 1.25.1+ds1

=== Makefile ===
# GNU Makefile

-include user.make

ifndef build
  build := release
endif

default: all

include Makerules

ifndef OUT
  OUT := build/$(build_prefix)$(build)$(build_suffix)
endif

include Makethird

# --- Configuration ---

# Do not specify CFLAGS, LDFLAGS, LIB_LDFLAGS, EXE_LDFLAGS or LIBS on the make
# invocation line - specify XCFLAGS, XLDFLAGS, XLIB_LDFLAGS, XEXE_LDFLAGS or
# XLIBS instead. Make ignores any lines in the makefile that set a variable
# that was set on the command line.
CFLAGS += $(XCFLAGS) -Iinclude
LIBS += $(XLIBS) -lm

LDFLAGS += $(XLDFLAGS)
LIB_LDFLAGS += $(XLIB_LDFLAGS)
EXE_LDFLAGS += $(XEXE_LDFLAGS)

ifneq ($(threading),no)
  ifeq ($(HAVE_PTHREAD),yes)
	THREADING_CFLAGS := $(PTHREAD_CFLAGS) -DHAVE_PTHREAD
	THREADING_LIBS := $(PTHREAD_LIBS)
  endif
endif

ifeq ($(HAVE_WIN32),yes)
  WIN32_LIBS := -lcomdlg32 -lgdi32
  WIN32_LDFLAGS := -Wl,-subsystem,windows
endif

VERSION_MAJOR = $(shell grep "define FZ_VERSION_MAJOR" include/mupdf/fitz/version.h | cut -d ' ' -f 3)
VERSION_MINOR = $(shell grep "define FZ_VERSION_MINOR" include/mupdf/fitz/version.h | cut -d ' ' -f 3)
VERSION_PATCH = $(shell grep "define FZ_VERSION_PATCH" include/mupdf/fitz/version.h | cut -d ' ' -f 3)

ifeq ($(LINUX_OR_OPENBSD),yes)
  ifneq ($(USE_SONAME),no)
    SO_VERSION = .$(VERSION_MINOR).$(VERSION_PATCH)
    ifeq ($(OS),Linux)
      SO_VERSION_LINUX := yes
    endif
  endif
endif

# --- Commands ---

ifneq ($(verbose),yes)
  QUIET_AR = @ echo "    AR $@" ;
  QUIET_RANLIB = @ echo "    RANLIB $@" ;
  QUIET_CC = @ echo "    CC $@" ;
  QUIET_CXX = @ echo "    CXX $@" ;
  QUIET_GEN = @ echo "    GEN $@" ;
  QUIET_LINK = @ echo "    LINK $@" ;
  QUIET_RM = @ echo "    RM $@" ;
  QUIET_TAGS = @ echo "    TAGS $@" ;
  QUIET_WINDRES = @ echo "    WINDRES $@" ;
  QUIET_OBJCOPY = @ echo "    OBJCOPY $@" ;
  QUIET_DLLTOOL = @ echo "    DLLTOOL $@" ;
  QUIET_GENDEF = @ echo "    GENDEF $@" ;
endif

MKTGTDIR = mkdir -p $(dir $@)
CC_CMD = $(QUIET_CC) $(MKTGTDIR) ; $(CC) $(CFLAGS) -MMD -MP -o $@ -c $<
CXX_CMD = $(QUIET_CXX) $(MKTGTDIR) ; $(CXX) $(CFLAGS) $(XCXXFLAGS) -MMD -MP -o $@ -c $<
AR_CMD = $(QUIET_AR) $(MKTGTDIR) ; $(AR) cr $@ $^
ifdef RANLIB
  RANLIB_CMD = $(QUIET_RANLIB) $(RANLIB) $@
endif
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
TAGS_CMD = $(QUIET_TAGS) ctags
WINDRES_CMD = $(QUIET_WINDRES) $(MKTGTDIR) ; $(WINDRES) $< $@
OBJCOPY_CMD = $(QUIET_OBJCOPY) $(MKTGTDIR) ; $(LD) -r -b binary -z noexecstack -o $@ $<
GENDEF_CMD = $(QUIET_GENDEF) gendef - $< > $@
DLLTOOL_CMD = $(QUIET_DLLTOOL) dlltool -d $< -D $(notdir $(^:%.def=%.dll)) -l $@

ifeq ($(shared),yes)
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(LDFLAGS) -o $@ \
	$(filter-out %.$(SO)$(SO_VERSION),$^) \
	$(sort $(patsubst %,-L%,$(dir $(filter %.$(SO)$(SO_VERSION),$^)))) \
	$(patsubst lib%.$(SO)$(SO_VERSION),-l%,$(notdir $(filter %.$(SO)$(SO_VERSION),$^))) \
	$(LIBS)
endif

# --- Rules ---

$(OUT)/%.a :
	$(AR_CMD)
	$(RANLIB_CMD)

$(OUT)/%.exe: %.c
	$(LINK_CMD)

$(OUT)/%.$(SO)$(SO_VERSION):
ifeq ($(SO_VERSION_LINUX),yes)
	$(LINK_CMD) -Wl,-soname,$(notdir $@) $(LIB_LDFLAGS) $(THIRD_LIBS) $(LIBCRYPTO_LIBS)
	ln -sf $(notdir $@) $(patsubst %$(SO_VERSION), %, $@)
else
	$(LINK_CMD) $(LIB_LDFLAGS) $(THIRD_LIBS) $(LIBCRYPTO_LIBS)
endif

$(OUT)/%.def: $(OUT)/%.$(SO)$(SO_VERSION)
	$(GENDEF_CMD)

$(OUT)/%_$(SO)$(SO_VERSION).a: $(OUT)/%.def
	$(DLLTOOL_CMD)

$(OUT)/source/helpers/mu-threads/%.o : source/helpers/mu-threads/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/source/helpers/pkcs7/%.o : source/helpers/pkcs7/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(LIBCRYPTO_CFLAGS)

$(OUT)/source/tools/%.o : source/tools/%.c
	$(CC_CMD) $(LIB_CFLAGS) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/generated/%.o : generated/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) -O0

$(OUT)/platform/x11/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS)

$(OUT)/platform/x11/curl/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS) $(CURL_CFLAGS)

$(OUT)/platform/gl/%.o : platform/gl/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THIRD_GLUT_CFLAGS)

ifeq ($(HAVE_OBJCOPY),yes)
  $(OUT)/source/fitz/noto.o : source/fitz/noto.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement -DHAVE_OBJCOPY $(LIB_CFLAGS) $(THIRD_CFLAGS)
endif

$(OUT)/source/fitz/memento.o : source/fitz/memento.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) -DMEMENTO_MUPDF_HACKS

$(OUT)/source/%.o : source/%.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)

$(OUT)/thirdparty/so/source/%.o : thirdparty/so/source/%.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)

$(OUT)/source/%.o : source/%.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS)

ifeq ($(HAVE_TESSERACT),yes)
$(OUT)/source/fitz/tessocr.o : source/fitz/tessocr.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(TESSERACT_CFLAGS) $(TESSERACT_DEFINES) $(TESSERACT_LANGFLAGS)
endif

ifeq ($(HAVE_LEPTONICA),yes)
$(OUT)/source/fitz/leptonica-wrap.o : source/fitz/leptonica-wrap.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(LEPTONICA_CFLAGS) $(LEPTONICA_DEFINES) $(LEPTONICA_BUILD_CFLAGS)
endif

$(OUT)/platform/%.o : platform/%.c
	$(CC_CMD) $(WARNING_CFLAGS)

$(OUT)/%.o: %.rc
	$(WINDRES_CMD)

.PRECIOUS : $(OUT)/%.o # Keep intermediates from chained rules
.PRECIOUS : $(OUT)/%.exe # Keep intermediates from chained rules

# --- File lists ---

THIRD_OBJ := $(THIRD_SRC:%.c=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cc=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cpp=$(OUT)/%.o)

THIRD_GLUT_OBJ := $(THIRD_GLUT_SRC:%.c=$(OUT)/%.o)

MUPDF_SRC := $(sort $(wildcard source/fitz/*.c))
MUPDF_SRC += $(sort $(wildcard source/fitz/*.cpp))
MUPDF_SRC += $(sort $(wildcard source/pdf/*.c))
MUPDF_SRC += $(sort $(wildcard source/xps/*.c))
MUPDF_SRC += $(sort $(wildcard source/svg/*.c))
MUPDF_SRC += $(sort $(wildcard source/html/*.c))
MUPDF_SRC += $(sort $(wildcard source/reflow/*.c))
MUPDF_SRC += $(sort $(wildcard source/cbz/*.c))

MUPDF_OBJ := $(MUPDF_SRC:%.c=$(OUT)/%.o)
MUPDF_OBJ := $(MUPDF_OBJ:%.cpp=$(OUT)/%.o)

THREAD_SRC := source/helpers/mu-threads/mu-threads.c
THREAD_OBJ := $(THREAD_SRC:%.c=$(OUT)/%.o)

PKCS7_SRC += source/helpers/pkcs7/pkcs7-openssl.c
PKCS7_OBJ := $(PKCS7_SRC:%.c=$(OUT)/%.o)

# --- Generated embedded font files ---

HEXDUMP_SH := scripts/hexdump.sh

FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallbackFull.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallback.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.otf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/sil/*.cff))

# Note: The tests here must match the equivalent tests in noto.c

ifneq ($(filter -DTOFU_CJK,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallback.ttf, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU_CJK_EXT,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU_CJK_LANG,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
endif

ifneq ($(filter -DTOFU_NOTO,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
endif

ifneq ($(filter -DTOFU_SIL,$(XCFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
endif

FONT_GEN := $(FONT_BIN:%=generated/%.c)

generated/%.cff.c : %.cff $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.otf.c : %.otf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.ttf.c : %.ttf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.ttc.c : %.ttc $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<

ifeq ($(HAVE_OBJCOPY),yes)
  MUPDF_OBJ += $(FONT_BIN:%=$(OUT)/%.o)
  $(OUT)/%.cff.o : %.cff ; $(OBJCOPY_CMD)
  $(OUT)/%.otf.o : %.otf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttf.o : %.ttf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttc.o : %.ttc ; $(OBJCOPY_CMD)
else
  MUPDF_OBJ += $(FONT_GEN:%.c=$(OUT)/%.o)
endif

generate: $(FONT_GEN)

# --- Generated ICC profiles ---

source/fitz/icc/%.icc.h: resources/icc/%.icc
	$(QUIET_GEN) xxd -i $< | \
		sed 's/unsigned/static const unsigned/' | \
		sed '1i// This is an automatically generated file. Do not edit.' \
		> $@

generate: source/fitz/icc/gray.icc.h
generate: source/fitz/icc/rgb.icc.h
generate: source/fitz/icc/cmyk.icc.h
generate: source/fitz/icc/lab.icc.h

# --- Generated CMap files ---

CMAP_GEN := $(notdir $(sort $(wildcard resources/cmaps/*)))
CMAP_GEN := $(CMAP_GEN:%=source/pdf/cmaps/%.h)

source/pdf/cmaps/%.h: resources/cmaps/% scripts/cmapdump.py
	$(QUIET_GEN) python3 scripts/cmapdump.py > $@ $<

generate: $(CMAP_GEN)

# --- Generated embedded javascript files ---

source/pdf/js/%.js.h: source/pdf/js/%.js scripts/jsdump.sed
	$(QUIET_GEN) sed -f scripts/jsdump.sed < $< > $@

generate: source/pdf/js/util.js.h

# --- Generated perfect hash source files ---

source/html/css-properties.h: source/html/css-properties.gperf
	$(QUIET_GEN) gperf > $@ $<

generate: source/html/css-properties.h

# --- Library ---

ifeq ($(shared),yes)
MUPDF_LIB = $(OUT)/libmupdf.$(SO)$(SO_VERSION)
ifeq ($(SO),dll)
MUPDF_LIB_IMPORT = $(OUT)/libmupdf_$(SO).a
LIBS_TO_INSTALL_IN_BIN = $(MUPDF_LIB)
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB_IMPORT)
else
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB)
endif
ifneq ($(USE_SYSTEM_GLUT),yes)
THIRD_GLUT_LIB = $(OUT)/libmupdf-glut.a
endif
THREAD_LIB = $(OUT)/libmupdf-threads.a
PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a

$(MUPDF_LIB) : $(MUPDF_OBJ) $(THIRD_OBJ)
$(THIRD_GLUT_LIB) : $(THIRD_GLUT_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)
else
MUPDF_LIB = $(OUT)/libmupdf.a
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB) $(THIRD_LIB)
THIRD_LIB = $(OUT)/libmupdf-third.a
ifneq ($(USE_SYSTEM_GLUT),yes)
THIRD_GLUT_LIB = $(OUT)/libmupdf-glut.a
endif
THREAD_LIB = $(OUT)/libmupdf-threads.a
PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THIRD_GLUT_LIB) : $(THIRD_GLUT_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)
endif

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)

# --- Main tools and viewers ---

MUTOOL_SRC := source/tools/mutool.c
MUTOOL_SRC += source/tools/muconvert.c
MUTOOL_SRC += source/tools/mudraw.c
MUTOOL_SRC += source/tools/murun.c
MUTOOL_SRC += source/tools/mutrace.c
MUTOOL_SRC += source/tools/cmapdump.c
MUTOOL_SRC += $(sort $(wildcard source/tools/pdf*.c))
MUTOOL_OBJ := $(MUTOOL_SRC:%.c=$(OUT)/%.o)
MUTOOL_EXE := $(OUT)/mutool$(EXE)
$(MUTOOL_EXE) : $(MUTOOL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(EXE_LDFLAGS) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
TOOL_APPS += $(MUTOOL_EXE)

MURASTER_OBJ := $(OUT)/source/tools/muraster.o
MURASTER_EXE := $(OUT)/muraster$(EXE)
$(MURASTER_EXE) : $(MURASTER_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(EXE_LDFLAGS) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
TOOL_APPS += $(MURASTER_EXE)

ifeq ($(HAVE_GLUT),yes)
  MUVIEW_GLUT_SRC += $(sort $(wildcard platform/gl/*.c))
  MUVIEW_GLUT_OBJ := $(MUVIEW_GLUT_SRC:%.c=$(OUT)/%.o)

=== docs/src/requirements.txt ===
rst2pdf

# define sphinx versioning
sphinx==5.3.0
sphinx_rtd_theme==1.1.1
readthedocs-sphinx-search==0.3.2
furo
sphinx_copybutton

=== debian/changelog ===
mupdf (1.25.1+ds1-7) unstable; urgency=high

  * Fix CVE-2025-46206: Infinite recursion in `mutool clean` when processing
    cyclic /Next references in PDF outlines. (Closes: #1110482)
    + Thanks to Yang Wang for preparing the update.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 07 Aug 2025 08:40:44 +0900

mupdf (1.25.1+ds1-6) unstable; urgency=medium

  * Fix segfault when using get_text() on arm64 (Closes: #1100748)
    + Thanks to Johannes Schauer for the patch
  * Update symbols file

 -- Daniel Echeverri <epsilon@debian.org>  Mon, 21 Apr 2025 17:12:48 -0500

mupdf (1.25.1+ds1-5) unstable; urgency=medium

  * Move to unstable. (Closes: #1091865)

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 11 Jan 2025 15:10:11 -0500

mupdf (1.25.1+ds1-4) experimental; urgency=medium

  * Add python3-mupdf package that contains mupdf python bindings.
  * debian/copyright
    + Extend debian copyright holder years.

 -- Daniel Echeverri <epsilon@debian.org>  Thu, 02 Jan 2025 21:59:47 -0500

mupdf (1.25.1+ds1-3) experimental; urgency=medium

  * Install libmupdfcpp library.
  * Update symbols file.

 -- Daniel Echeverri <epsilon@debian.org>  Wed, 01 Jan 2025 21:17:25 -0500

mupdf (1.25.1+ds1-2) experimental; urgency=medium

  * Install missing header files.

 -- Daniel Echeverri <epsilon@debian.org>  Mon, 30 Dec 2024 20:56:45 -0500

mupdf (1.25.1+ds1-1) experimental; urgency=medium

  * New upstream release. (Closes: #1089681)
  * debian/control
    + Add libmupdf25.1 package. (Closes: #719351)
    + Add python3-dev, python3-clang, swig, python3-sphinx-copybutton in BD.
    + Add ${sphinxdoc:Depends} in Depends.
  * Remove unused lintian overrides.
  * debian/patches
    + Add 0010_add_missing_hardening_flags.diff
    + Refresh 0008-Add-fallback-for-missing-SA_NOCLDWAIT.patch
  * Rename mupdf.pc to mupdf.pc.in
  * debian/rules
    + update rules to build shared library.
    + Add override to build doc with sphinxdoc.
  * Add libmupdf25.1.install file.
  * Update libmupdf-dev.install to install the lib.
  * Remove -static from debian/tests/Makefile.
  * Add libmupdf25.1.symbols file.

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 19 Oct 2024 10:18:38 -0500

=== debian/control ===
--- 
+++ 
@@ -25,10 +25,10 @@
                libxext-dev,
                pkgconf,
 	       dh-sequence-python3,
-               python3-all-dev,
+	       python3-all,
                python3-clang,
+               python3-dev:any,
                python3-docutils,
-               python3-roman,
                python3-pygments,
                python3-sphinx-copybutton,
                python3-sphinx-rtd-theme,
@@ -38,7 +38,7 @@
                texlive-fonts-extra,
                unzip,
                zlib1g-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://mupdf.com/
 Vcs-Git: https://salsa.debian.org/debian/mupdf.git

=== debian/watch ===
version=4
opts=repacksuffix=+ds1,dversionmangle=s/\+ds\d*$//,uversionmangle=s/(\d[^_\-\.]?)[_\-\.](source?)$/$1/ \
https://mupdf.com/releases/ \
(?:.*/|.*=|)mupdf[\-\._]?([0-9.]+)-source\.(?:tar\.xz|tar\.gz)

## mupdf 1.27.0%2Bds1

=== debian/changelog ===
mupdf (1.27.0+ds1-3) unstable; urgency=medium

  * debian/patches
    + Fix CVE-2026-25556 double-free in
      fz_fill_pixmap_from_display_list(). (Closes: #1127318)

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 07 Feb 2026 19:18:33 -0500

mupdf (1.27.0+ds1-2) unstable; urgency=medium

  * Move to unstable

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 17 Jan 2026 20:58:22 -0500

mupdf (1.27.0+ds1-1) experimental; urgency=medium

  * New upstream version 1.27.0+ds1 (Closes: #1117598)
  * debian/control
    + Rename lib package to libmupdf27.0 for new soname
    + Add libgl-dev, libxrandr-dev, libbrotli-dev,libzxing-dev in B-D
    + Add python3-myst-parser in B-D (Closes: #1123406)
    + Add fonts-noto-ui-core in B-D
    + Remove Rules-Requires-Root field
  * debian/patches
    + Add 0011-use-inline-mujs-regexp.patch
      + Inline mujs regexp definitions to build against system libmujs
    + Add 0012-exclude-unavailable-noto-fonts.patch
      + Exclude Noto fonts not available in Debian packages
    + Add 0013-remove-unavailable-sphinx-extensions.patch
      + Remove unavailable and unwanted Sphinx extensions
    + Add fix-mutool-manpage-groff-errors.patch
      + Fix groff errors in mutool manpage
    + Add 0014-add-py-limited-api-build-suffix.patch
      + Avoid segfaults by separating Py_LIMITED_API builds (Closes: #1122041)
    + Remove debian/patches/fix-cve-2025-46206.patch
      + Merge with upstream
    + Remove debian/patches/0008-define-SONAME-header.patch
      + Merge with upstream
    + Refresh other patches
  * debian/rules
    + Add target extra-apps to build muraster and other tools
    + Update dh_installman and dh_sphinxdoc overrides
    + Disable parallel builds to avoid build issues
    + Update override_dh_clean to delete some resources.
  * debian/debian/mupdf-tools.install
    + Adjust install paths for relocated muraster binary
  * debian/mupdf-tools.manpages
    + Provide muraster doc from debian/ since upstream no longer ships it
  * Rename libmupdf25.1.symbols to libmupdf27.0.symbols
    + Update some symbols
    + Add Build-Depends-Package field
  * Update debian/watch to fetch tarball url correctly
  * Rename libmupdf25.1.install to libmupdf27.0.install
  * Extend diff-ignore to exclude thirdparty/zint and thirdparty/zxing-cpp
  * debian/copyright
    + Extend debian copyright holder years

 -- Daniel Echeverri <epsilon@debian.org>  Tue, 06 Jan 2026 21:24:02 -0500

mupdf (1.25.1+ds1-9) unstable; urgency=medium

  * debian/control
    + Add python3-roman in B-D
  * debian/patches
     + Remove 0011-fix-FTBFS-disable-rst2pdf-on-html-build.diff
       + that caused regressions fails in pymupdf. (Closes: #1119022)

 -- Daniel Echeverri <epsilon@debian.org>  Sun, 26 Oct 2025 09:57:18 -0500

mupdf (1.25.1+ds1-8) unstable; urgency=medium

  * debian/control
    + Replace python3-all, python3-dev with python3-all-dev (Closes: #1118662)
    + Bump standards-version to 4.7.2, no changes needed
  * debian/patches
    + Add 0011-fix-FTBFS-disable-rst2pdf-on-html-build.diff
      + Disable rst2pdf on html build. (Closes: #1118307)

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 25 Oct 2025 08:52:52 -0500
